import processing.video.*;

int numPixelsWide, numPixelsHigh;
int blockSize = 10;
Movie mov;
color movColors[];
int colors_to_send[];
String cts;
int pixelwidth = 6;
int pixelheight = 4;

int numPixels;
color black = color(0,1);
color white = color(255);

void setup() 
{
  size(640, 360);
  noStroke();
  mov = new Movie(this, "transit.mov");
  mov.loop();
  numPixelsWide = pixelwidth;  
  numPixelsHigh = pixelheight;  
  println(numPixelsWide);
  movColors = new color[numPixelsWide * numPixelsHigh];
  colors_to_send = new int[numPixelsWide * numPixelsHigh];
}

// Display values from movie
void draw() 
{
  if (mov.available() == true) 
  {
    mov.read();
    mov.loadPixels();
     
    int count = 0;
    for (int j = 0; j < numPixelsHigh; j++) 
    {
      for (int i = 0; i < numPixelsWide; i++) 
      {
        movColors[count] = mov.get(i*width/pixelwidth, j*height/pixelheight);
        count++;
      }
    }
  }

  //background(255);
  for (int j = 0; j < numPixelsHigh; j++) 
  {
    for (int i = 0; i < numPixelsWide; i++) 
    {
      int fillcolor = 0;
      fillcolor = ((brightness(movColors[j*numPixelsWide + i])>128)) ? 255 : 0;
      fill(fillcolor);
      colors_to_send[j*numPixelsWide + i] = fillcolor;
      noStroke();
      rect(i*width/pixelwidth, j*height/pixelheight, width/pixelwidth+1, height/pixelheight+1);
      fill(0,255,0);
      text(j*numPixelsWide + i,i*width/pixelwidth+20, j*height/pixelheight+20);
    }
  }
  
  cts = "<" +       nf(colors_to_send[0], 3) +
              " " + nf(colors_to_send[1], 3) +
              " " +nf(colors_to_send[2], 3) +
              " " +nf(colors_to_send[3], 3) +
              " " +nf(colors_to_send[4], 3) +
              " " +nf(colors_to_send[5], 3) +
              " " +nf(colors_to_send[6], 3) +
              " " +nf(colors_to_send[7], 3) +
              " " +nf(colors_to_send[8], 3) +
              " " +nf(colors_to_send[9], 3) +
              " " +nf(colors_to_send[10], 3) +
              " " +nf(colors_to_send[11], 3) +
              " " +nf(colors_to_send[12], 3) +
              " " +nf(colors_to_send[13], 3) +
              " " +nf(colors_to_send[14], 3) +
              " " +nf(colors_to_send[15], 3) +
              " " +nf(colors_to_send[16], 3) +
              " " +nf(colors_to_send[17], 3) +
              " " +nf(colors_to_send[18], 3) +
              " " +nf(colors_to_send[19], 3) +
              " " +nf(colors_to_send[20], 3) +
              " " +nf(colors_to_send[21], 3) +
              " " +nf(colors_to_send[22], 3) +
              " " +nf(colors_to_send[23], 3) +
              ">";
  println(cts);
  //  myPort.write(cts);
  
  /*  
    
    //arduino side:
  
    int arrIndex = 0;
    int arrayOfNums[24];

    char *token = strtok (myArrayName," ");
    while (token != NULL)
    {
      int aNum = atoi(token);
      if(arrIndex <= 23)
      {
       arrayOfNums[arrIndex] = aNum;
       arrIndex++;
      }
      token = strtok (NULL, " ");
    }
  */
  
  
}

